<!-- 检定记录 -->
<script lang="ts" setup name="MeasureRecords">
import dayjs from 'dayjs'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { measureRecordsById } from '@/api/business/schedule/task'
const props = defineProps({
  // 样品id
  sampleId: {
    type: String,
    required: true,
  },
  // 客户id
  customerId: {
    type: String,
    required: true,
  },
})

// 查询条件
const searchQuery = ref({
  sampleId: props.sampleId,
  customerId: props.customerId,
  limit: 10,
  offset: 1,
})

// 检定记录
interface SimpleMeasureRecord {
  orderCode: string // 委托单编号
  orderTime: string // 委托单日期
  customerCode: string // 委托人代码
  customerName: string // 委托人名称
  deliverer: string // 送检人
  deliverTime: string // 送检日期
}

// 表格表头
const columns = ref<TableColumn[]>([
  { text: '委托单编号', value: 'orderCode', align: 'center', width: '160' },
  { text: '委托单日期', value: 'orderTime', align: 'center', width: '120' },
  { text: '委托方代码', value: 'customerCode', align: 'center', width: '160' },
  { text: '委托方名称', value: 'customerName', align: 'center' },
  { text: '送检人', value: 'deliverer', align: 'center' },
  { text: '送检日期', value: 'deliverTime', align: 'center', width: '120' },
])

// 证书列表
const list = ref<SimpleMeasureRecord[]>([])
const total = ref(0)
// 加载状态
const loading = ref(false)
// 查找证书状态及列表
function fetchData(isNowPage = false) {
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    searchQuery.value.offset = 1
  }
  loading.value = true
  list.value = []
  measureRecordsById({ ...searchQuery.value }).then((res) => {
    list.value = res.data.rows.map((item: any) => {
      return {
        ...item,
        orderTime: item.orderTime ? dayjs(item.orderTime).format('YYYY-MM-DD') : item.orderTime,
        deliverTime: item.deliverTime ? dayjs(item.deliverTime).format('YYYY-MM-DD') : item.deliverTime,
      }
    })
    total.value = parseInt(res.data.total)
  })
  loading.value = false
}
fetchData()

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.value.limit = val.size
  }
  if (val && val.page) {
    searchQuery.value.offset = val.page
  }
  fetchData(true)
}
</script>

<template>
  <div>
    <normal-table
      :data="list"
      :total="total"
      :query="searchQuery"
      :columns="columns"
      :list-loading="loading"
      :pagination="true"
      :page-sizes="[10, 20, 30]"
      @change="changePage"
    >
      <template #preColumns>
        <el-table-column label="序号" width="55" align="center">
          <template #default="scope">
            {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
          </template>
        </el-table-column>
      </template>
    </normal-table>
  </div>
</template>
